package cn.com.brilliance.doc.utils;

import com.spire.pdf.FileFormat;
import com.spire.pdf.PdfDocument;
import lombok.extern.slf4j.Slf4j;

/**
 * word:pdf To docx file util
 *
 * @author weiguanying
 * Date 2023.02.19
 */
@Slf4j
public class PDFToWord {

    public void PDFToWord(String filePath, String targetPath) {

        // 代码运行开始时间
        Long startTime = System.currentTimeMillis();

        // 打印说明
        String note = "程序执行时长";

        //Create a PdfDocument object
        PdfDocument doc = new PdfDocument();

        //Load a sample PDF document
        doc.loadFromFile(filePath);

        //Convert PDF to Doc and save it to a specified path
        //doc.saveToFile("d:\\ToPDF.doc", FileFormat.DOC);

        //Convert PDF to Docx and save it to a specified path
        doc.saveToFile(targetPath, FileFormat.DOCX);
        doc.close();
        // 代码运行结束时间
        Long endTime = System.currentTimeMillis();
        log.info("PDFToWord >> " + note + ":" + (endTime - startTime));
        //System.out.println(note + ":" + (endTime - startTime));

    }
}
