package cn.com.brilliance.doc.utils;

import com.spire.doc.Document;
import com.spire.doc.ToPdfParameterList;
import lombok.extern.slf4j.Slf4j;

/**
 * word:docx To pdf file util
 *
 * @author weiguanying
 * Date 2023.02.19
 */
@Slf4j
public class WordToPDF {
    public void doxcTopdf(String filePath, String targetPath, String licenseKey) {

//        if (licenseKey != null && !"".equals(licenseKey)) {
//            com.spire.license.LicenseProvider.setLicenseKey("licenseKey");
//            com.spire.license.LicenseProvider.loadLicense();
//        }

        // 代码运行开始时间
        Long startTime = System.currentTimeMillis();

        // 打印说明
        String note = "程序执行时长";
        Document doc = new Document();

        // Load a sample Word document
        doc.loadFromFile(filePath);

        // Create a ToPdfParameterList instance
        ToPdfParameterList ppl = new ToPdfParameterList();

        // Embed all fonts in the PDF document
        ppl.isEmbeddedAllFonts(true);

        // Remove the hyperlinks and keep the character formats
        ppl.setDisableLink(true);

        // Set the output image quality as 40% of the original image. 80% is the default setting.
        doc.setJPEGQuality(40);

        // Save the document as PDF
        doc.saveToFile(targetPath, ppl);
        Long endTime = System.currentTimeMillis();

        log.info("PDFToWord >> " + note + ":" + (endTime - startTime));

    }
}

