package cn.com.brilliance.dsp.test;

import cn.com.brilliance.dsp.config.DocBean;
import cn.com.brilliance.dsp.model.*;
import cn.com.brilliance.dsp.service.FrameService;
import cn.com.brilliance.dsp.utils.Result;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestParam;

import java.io.*;
import java.util.*;

public class Test01 {


    private static final String KEYONE = "FrameField";
    private static final String KEYTWO = "FieldValue";
    private static final String KEYTHREE = "FramePanel";
    private static final String KEYFOUR = "GridValue";
    private static final String KEYFIVE = "GridLists";
    private static final String KEYSIX = "Label";
    private static final String KEYSEVEN = "Grid";



    @Autowired
    private static DocBean docBean;
    @Autowired
    private static FrameService frameService;

    public static void main(String[] args) throws Exception {
        List<String> lists = new ArrayList<>();
        lists.add("10000059.DSP");
        lists.add("10000302.DSP");
        lists.add("10000400.DSP");
        lists.add("10000401.DSP");
        lists.add("10000402.DSP");
        lists.add("10000403.DSP");
        lists.add("10000404.DSP");
        lists.add("10000557.DSP");
        lists.add("10000594.DSP");
        lists.add("10000595.DSP");
        lists.add("10004105.DSP");
        lists.add("10004145.DSP");
        lists.add("10004200.DSP");
        lists.add("10004205.DSP");
        lists.add("10004208.DSP");
        lists.add("10004218.DSP");
        lists.add("10004221.DSP");
        lists.add("10004230.DSP");
        lists.add("10004244.DSP");
        lists.add("10004248.DSP");
        lists.add("10004256.DSP");
        lists.add("10004259.DSP");
        lists.add("10004260.DSP");
        lists.add("10004279.DSP");
        lists.add("10004292.DSP");
        lists.add("10004298.DSP");
        lists.add("10004300.DSP");
        lists.add("10004304.DSP");
        lists.add("10004307.DSP");
        lists.add("10004317.DSP");
        lists.add("10004326.DSP");
        lists.add("10004334.DSP");
        lists.add("10004343.DSP");
        lists.add("10004348.DSP");
        lists.add("10004352.DSP");
        lists.add("10004360.DSP");
        lists.add("10004364.DSP");
        lists.add("10004439.DSP");
        lists.add("10004441.DSP");
        lists.add("10004449.DSP");
        lists.add("10004457.DSP");
        lists.add("10004461.DSP");
        lists.add("10004463.DSP");
        lists.add("10004465.DSP");
        lists.add("10004466.DSP");
        lists.add("10004470.DSP");
        lists.add("10004478.DSP");
        lists.add("10004479.DSP");
        lists.add("10004487.DSP");
        lists.add("10004492.DSP");
        lists.add("10004499.DSP");
        lists.add("10004500.DSP");
        lists.add("10004502.DSP");
        lists.add("10004509.DSP");
        lists.add("10004520.DSP");
        lists.add("10004525.DSP");
        lists.add("10004532.DSP");
        lists.add("10004539.DSP");
        lists.add("10004571.DSP");
        lists.add("10004588.DSP");
        lists.add("10004590.DSP");
        lists.add("10004591.DSP");
        lists.add("10004594.DSP");
        lists.add("10004595.DSP");
        lists.add("10004722.DSP");
        lists.add("10004734.DSP");
        lists.add("10006481.DSP");
        lists.add("10006482.DSP");
        lists.add("10006483.DSP");
        lists.add("10006486.DSP");
        lists.add("10006570.DSP");
        lists.add("10006627.DSP");
        lists.add("10006633.DSP");
        lists.add("10006639.DSP");
        lists.add("10006649.DSP");
        lists.add("10006685.DSP");
        lists.add("10006691.DSP");
        lists.add("10006701.DSP");
        lists.add("10006712.DSP");
        lists.add("10006717.DSP");
        lists.add("10006766.DSP");
        lists.add("10006774.DSP");
        lists.add("10006836.DSP");
        lists.add("10006881.DSP");
        lists.add("10006932.DSP");
        lists.add("10007078.DSP");
        lists.add("10007150.DSP");
        lists.add("10007161.DSP");
        lists.add("10007303.DSP");
        lists.add("10007320.DSP");
        lists.add("test.DSP");
        lists.add("test3.DSP");

        for (String list : lists) {
            dspParse(list);
        }}



    @Test
        public static <T> Result dspParse(String fileName) throws Exception {
            //获取上传文件名称
            //String fileName = file.getOriginalFilename();
            //获取上传文件类型
            //String contentType = file.getContentType();
            String filePath = docBean.getFilePath() + fileName;
            String fileType = fileName.substring(fileName.indexOf(".") + 1);
            if (!"DSP".equals(fileType)) {
                return Result.error().message("文件格式错误!");
            }
            //获取上传文件输入流，便于文件内容读写操作
            FileInputStream inputStream = new FileInputStream(filePath);
            InputStreamReader inputStreamReader = new InputStreamReader(inputStream, "GB2312");
            BufferedReader reader = new BufferedReader(inputStreamReader);
            // 解析文件内容并返回
            List<Panel> panelList = new ArrayList<>();
            Panel panel = new Panel();
            List<Table> tableList = null;
            FrameField frameField = null;
            List<T> list = null;
            String prop = null;
            List<String> tableValues =null;

            Table table1 = null;

            List<String> props = null;
            List<String> widths = null;
            Grid grid = null ;

            List<GridValue> gridValues = null ;
            try {
                String line;
                while ((line = reader.readLine()) != null) {
                    // 读取到的结果
                    HashMap<String, Object> result = frameService.printEibsElement(line);
                    if (result != null) {
                        // 多个panel组装
                        if (result.containsKey(KEYTHREE)) {
                            panel = (Panel) result.get(KEYTHREE);
                            panelList.add(panel);
                            list = new ArrayList<>();
                        }
                        // 多个field组装
                        if (result.containsKey(KEYONE)) {
                            frameField = (FrameField) result.get(KEYONE);
                            list.add((T) frameField);
                        }
                        // 多个value组装到上一行的field上
                        if (result.containsKey(KEYTWO)) {
                            FrameField frameValue = (FrameField) result.get(KEYTWO);
                            FrameField ff = (FrameField) list.get(list.size() - 1);
                            ff.setValue(ff.getValue() != null ? ff.getValue()  + frameValue.getValue() : frameValue.getValue());
                            list.remove(list.get(list.size() - 1));
                            ff.setValue(ff.getValue().replaceAll("\u001F", ""));
                            list.add((T) ff);
                            panel.setList(list);
                        }


                        if (result.containsKey(KEYSIX)) {
                            Label label = (Label) result.get(KEYSIX);
                            label.setViewType("Label");
                            list.add((T) label);
                            panel.setList(list);
                        }

//                    if (result.containsKey(KEYSEVEN)) {
//                        tableList = new ArrayList<>();
//                        table1 = new Table();
//                        props = new ArrayList<>();
//                        widths = new ArrayList<>();
//                        tableValues = new ArrayList<>();
//                        grid = new Grid();
//                    }
//
//                        if (result.containsKey(KEYFIVE)) {
//                        GridLists gridLists = (GridLists) result.get(KEYFIVE);
//                            widths.add(gridLists.getWidth());
//                            frameField.setWidths(widths);
//                    }
//
//                    if (result.containsKey(KEYFOUR)) {
//                        GridValue gridValue = (GridValue) result.get(KEYFOUR);
//                        if ("0".equals(gridValue.getRow())) {
//                            prop = gridValue.getValue();
//                            props.add(prop);
//                            frameField.setProps(props);
//                        } else  {
//                          //  if (Integer.parseInt(gridValue.getRow()) < Integer.parseInt(grid.getRows()) - 1 ){
//                            tableValues.add(gridValue.getValue());
//                         //   } else {
//                           //     tableValues.add(gridValue.getValue() + "&&");
//                          //  }
//                            frameField.setTableValues(tableValues);
//                        }
//                        FrameField ff = (FrameField) list.get(list.size() - 1);
//                        list.remove(list.get(list.size() - 1));
//                        list.add((T) ff);
//                        panel.setList(list);
//                    }



//                    if (result.containsKey(KEYSEVEN)) {
//                        tableList = new ArrayList<>();
//                        table1 = new Table();
//                        props = new ArrayList<>();
//                        widths = new ArrayList<>();
//                        tableValues = new ArrayList<>();
//
//
//                    }
//
//                    if (result.containsKey(KEYFIVE)) {
//                        GridLists gridLists = (GridLists) result.get(KEYFIVE);
//                        table1 = new Table();
//                        table1.setWidth(gridLists.getWidth());
//                        tableList.add(table1);
//                    }
//
//                    if (result.containsKey(KEYFOUR)) {
//                        GridValue gridValue = (GridValue) result.get(KEYFOUR);
//                        int i  = Integer.parseInt(gridValue.getRow());
//                        int j = Integer.parseInt(gridValue.getColumn());
//                        if (i == 0) {
//                            Table table2 = tableList.get(i);
//                            table2.setProp(gridValue.getValue());
//                            tableList.remove(j);
//                            tableList.add(j,table2);
//                        } else {
//                            Table table2 = tableList.get(i);
//                            //table2.setProp(gridValue.getValue());
//                            tableValues.add(gridValue.getValue());
//                            table2.setValues(tableValues);
//                        }
//                        frameField.setTableList(tableList);
//                    }



                        if (result.containsKey(KEYSEVEN)) {
                            Grid grid1 = (Grid) result.get(KEYSEVEN);
                            widths = new ArrayList<>();
                            gridValues = new ArrayList<>();
                        }

                        if (result.containsKey(KEYFIVE)) {
                            GridLists gridLists = (GridLists) result.get(KEYFIVE);
                            widths.add(gridLists.getWidth());
                        }

                        if (result.containsKey(KEYFOUR)) {
                            GridValue gridValue = (GridValue) result.get(KEYFOUR);
                            gridValue.setWidth(widths.get(Integer.parseInt(gridValue.getColumn())));
                            gridValues.add(gridValue);
                            FrameField ff = (FrameField) list.get(list.size() - 1);
                            ff.setGridValues(gridValues);
                            list.remove(list.get(list.size() - 1));
                            list.add((T) ff);
                            panel.setList(list);
                        }
                    }
                }

            } catch (Exception e) {
                return Result.error().message("DSP文件解析失败!");
            }
            // 关闭流对象
            if (inputStream != null) {
                inputStream.close();
            }
            if (inputStreamReader != null) {
                inputStreamReader.close();
            }
            if (reader != null) {
                reader.close();
            }
            Object o = panelList;
            Map<String, Object> map = new HashMap<>();
            map.put("panelLists", o);
            return Result.ok().data(map);
        }

}
